export declare type Constructor<T> = new (...args: any[]) => T;
export declare type DataKeys<T> = {
    [K in keyof T]: T[K] extends Function ? never : K;
}[keyof T];
export declare function isEmpty(value: any): boolean;
export declare function byteLength(raw: string): number;
export declare function uniqueID(): string;
export declare function differ<T>(target: Record<string, T>, source: Record<string, T>): Record<string, T>;
export declare type GroupKey = string | number;
export declare type Iteratee<T> = GroupKey | ((item: T) => GroupKey | GroupKey[]);
export declare function groupBy<T extends Record<string, any>>(list: T[], iteratee: Iteratee<T>): Record<string | number, T[]>;
export declare function parseJSON(value: string): any;
export declare function parseTextTable<T = {}>(raw: string, header?: boolean, separator?: string): any[];
/**
 * CRC-32 algorithm forked from Bakasen's
 * http://blog.csdn.net/bakasen/article/details/6043797
 */
export declare function makeCRC32(raw: string): string;
declare type SHAAlgorithm = 'SHA-1' | 'SHA-256' | 'SHA-384' | 'SHA-512';
/**
 * @see https://developer.mozilla.org/en-US/docs/Web/API/SubtleCrypto/digest#Converting_a_digest_to_a_hex_string
 */
export declare function makeSHA(raw: string, algorithm?: SHAAlgorithm): Promise<string>;
export {};
